#include "fxlib.h"
#include "MonochromeLib.h"
#include "physique.h"
#include <math.h>
#include <stdio.h>
#include <stdlib.h>

char affiche[25];
int vaissseau;
static int SysCallCode[] = {0xD201422B,0x60F20000,0x80010070};
static int (*SysCall)(int R4, int R5, int R6, int R7, int FNo ) = (void*)&SysCallCode;

// OK
etape1(int vaiso)
{
	int succes=0;
	// Cas GTO Standard : pousser à l'apogée, la vitesse doit y 
    // être un peu supérieure à 3 Km/s
    // CONSEIL : ne manoeuvrer qu'à l'apogée ou au périgée.
    // Satellite au départ (masse 1 kg)
    // x,y,vx,vy Position et Vitesse courants du satellite
    double x = XTA + RAYT*1.1;
    double y = YT;
    double vx = 0.08;
    double vy = -1.385;
    int tempsMax = 1500;
	vaissseau=vaiso;
	
	// Trace Corps
	ML_filled_circle(XTA, YT, RAYT, ML_BLACK);
	// Trace Zone Geo
	ML_circle(XTA, YT, RGEOMIN, ML_CHECKER);
	ML_circle(XTA, YT, RGEOMAX, ML_CHECKER);
	ML_display_vram();
	SaveDisp(1);
	
    succes = anime12(x, y, vx, vy, tempsMax);
	return succes;
}

// OK
etape2(int vaiso)
{
	int succes=0;
	// Cas GTO Standard : pousser à l'apogée, la vitesse doit y 
    // être un peu supérieure à 3 Km/s
    // CONSEIL : ne manoeuvrer qu'à l'apogée ou au périgée.
    // Satellite au départ (masse 1 kg)
    // x,y,vx,vy Position et Vitesse courants du satellite
    double x = XTA + RAYT*1.1;
    double y = YT;
	double alea=0.95+0.1*rand_int(2);
    double vx = 0.08 * alea;
    double vy = -1.385 * alea;
    int tempsMax = 1500;
	srand(RTC_getTicks());
	vaissseau=vaiso;
	
	// Trace Corps
	ML_filled_circle(XTA, YT, RAYT, ML_BLACK);
	// Trace Zone Geo
	ML_circle(XTA, YT, RGEOMIN, ML_CHECKER);
	ML_circle(XTA, YT, RGEOMAX, ML_CHECKER);
	ML_display_vram();
	SaveDisp(1);
	
    succes = anime12(x, y, vx, vy, tempsMax);
	return succes;
}

// OK
etape3(int vaiso)
{
	// ETAPE 3 :
    // Faire un crash sur la Lune
	
    int succes = 0;
    // x,y,vx,vy Position et Vitesse courants du satellite
    double x = XTB + RAYT*1.1;
    double y = YT;
    // Aléa d'injection: plus ou moins 5% de la vitesse
    double alea = 0.98 + 0.04 * rand_int(2);
    double vx = 0.08 * alea;
    double vy = 1.385 * alea;
	
    int tempsMax = 1500;
	vaissseau=vaiso;
	
	// Trace Corps
	ML_filled_circle(XTB, YT, RAYT, ML_BLACK);
	ML_filled_circle(XL, YL, RAYL, ML_BLACK);
	ML_display_vram();
	SaveDisp(1);
	
    succes = anime3(x, y, vx, vy, tempsMax);
	return succes;
}

// OK
etape4(int vaiso)
{
	// ETAPE 4 :
    // Faire un passage derrière la lune puis venir se crasher 
    // sur la Terre.
	int succes = 0;
    // x,y,vx,vy Position et Vitesse courants du satellite
    double x = XTB + RAYT*1.1;
    double y = YT;
    // Aléa d'injection: plus ou moins 5% de la vitesse
    double alea = 0.98 + 0.04 * rand_int(2);
    double vx = 0.08 * alea;
    double vy = 1.385 * alea;
	
    int tempsMax = 1500;
	vaissseau=vaiso;
	// Trace Corps
	ML_filled_circle(XTB, YT, RAYT, ML_BLACK);
	ML_filled_circle(XL, YL, RAYL, ML_BLACK);
	ML_display_vram();
	SaveDisp(1);
	
    succes = anime4(x, y, vx, vy, tempsMax);
	return succes;
}

// OK
etape5(int vaiso)
{
	// ETAPE 5 :
    // Se mettre en orbite autour de la lune !
	int succes = 0;
    // x,y,vx,vy Position et Vitesse courants du satellite
    double x = XTB + RAYT*1.1;
    double y = YT;
    // Aléa d'injection: plus ou moins 5% de la vitesse
    double alea = 0.98 + 0.04 * rand_int(2);
    double vx = 0.08 * alea;
    double vy = 1.385 * alea;
	
    int tempsMax = 1500;
	vaissseau=vaiso;
	// Trace Corps
	ML_filled_circle(XTB, YT, RAYT, ML_BLACK);
	ML_filled_circle(XL, YL, RAYL, ML_BLACK);
	ML_display_vram();
	SaveDisp(1);
	
    succes = anime5(x, y, vx, vy, tempsMax);
	return succes;
}

// OK
anime12(double x, double y, double vx, double vy, int tmax)
{
    int succes = 0;
	int i=0;
	double vit;
	double valeurs[4];
	double xg, yg;
	int premierOK = 0;
	int dansZoneGeo = 0;
	
    while (i<tmax){
        i++;
        integreUnPasTerre(x, y, vx, vy, valeurs);
		
		//dx  = valeurs[0]
		//dy  = valeurs[1]
		//dvx = valeurs[2]
		//dvy = valeurs[3]
		
        x += valeurs[0];
        y += valeurs[1];
        vx += valeurs[2];
        vy += valeurs[3];
		xg = x;
		yg = y;
		// CADRAGE
        if (x<1) xg = 1;
        if (x>XMAX) xg = XMAX;
        if (y<1) yg = 1;
        if (y>YMAX) yg = YMAX;
		
		// AFFICHAGE
		Bdisp_AllClr_DDVRAM();
		RestoreDisp(1);
		vit = sqrt(vx*vx+vy*vy);
		sprintf(affiche,"Vitesse:");
		PrintMini(0,YVITESSE,affiche,0);
		sprintf(affiche,"%5.2f Km/s",COEFR*(vit));
		PrintMini(0,YVITESSE+6,affiche,0);
        affiche_vaisseau(xg,yg);
		Bdisp_PutDisp_DD();
		Sleep(100);
		
		// INTERACTION POUR MANOEUVRES
		// Augmenter vitesse de DVINC
		if(IsKeyDown(137) || IsKeyDown(30018)){
            vx = vx+DVINC*vx/vit;
            vy = vy+DVINC*vy/vit;
		}
		// quitter
		if(IsKeyDown(30002)){
			succes=3;
			break;
		}
		if(IsKeyDown(153) || IsKeyDown(30023)){
            vx = vx-DVINC*vx/vit;
            vy = vy-DVINC*vy/vit;
		}
		
		// TESTS
		// Crash
        if(crashed(RAYT, XTA, YT, x, y)) break;
		// Test zone Geo atteinte : ok si dans la zone depuis environ une orbite
        dansZoneGeo = GeoOK(x, y);
		if (dansZoneGeo!=1) premierOK = i;
        if ((i-premierOK)>NBPOKGEO){
			succes = 1;
			break;
		}
    }
	return succes;
}

// OK
anime3(double x, double y, double vx, double vy, int tmax)
{
	int succes = 0;
	int i=0;
	double vit;
	double valeurs[4];
	double xg, yg;
	
	while (i<tmax){
		i++;
        integreUnPasTerreLune(x, y, vx, vy, valeurs);
		
		//dx  = valeurs[0]
		//dy  = valeurs[1]
		//dvx = valeurs[2]
		//dvy = valeurs[3]
		
        x += valeurs[0];
        y += valeurs[1];
        vx += valeurs[2];
        vy += valeurs[3];
		xg = x;
		yg = y;
		// CADRAGE
        if (x<1) xg = 1;
        if (x>XMAX) xg = XMAX;
        if (y<1) yg = 1;
        if (y>YMAX) yg = YMAX;
		
		// AFFICHAGE
		Bdisp_AllClr_DDVRAM();
		RestoreDisp(1);
		vit = sqrt(vx*vx+vy*vy);
		sprintf(affiche,"Vitesse:");
		PrintMini(0,YVITESSE,affiche,0);
		sprintf(affiche,"%5.2f Km/s",COEFR*(vit));
		PrintMini(0,YVITESSE+6,affiche,0);
        affiche_vaisseau(xg,yg);
		Bdisp_PutDisp_DD();
		Sleep(100);
		
		// INTERACTION POUR MANOEUVRES
		// Augmenter vitesse de DVINC
		if(IsKeyDown(137) || IsKeyDown(30018)){
            vx = vx+DVINC*vx/vit;
            vy = vy+DVINC*vy/vit;
		}
		// quitter
		if(IsKeyDown(30002)){
			succes=3;
			break;
		}
		// Reduire vitesse de DVINC
		if(IsKeyDown(153) || IsKeyDown(30023)){
            vx = vx-DVINC*vx/vit;
            vy = vy-DVINC*vy/vit;
		}
		
		// TESTS
		// Crash Terre
        if(crashed(RAYT, XTB, YT, x, y)) break;
		// Crash Lune
		if(crashed(RAYL, XL, YL, x, y)){
			succes=1;
			break;
		}
    }
	return succes;
}

// OK
anime4(double x, double y, double vx, double vy, int tmax)
{
	int succes = 0;
	int passLune = 0;
	int crashT = 0;
	int i=0;
	double vit;
	double valeurs[4];
	double xg, yg;
	
	while (i<tmax){
		i++;
        integreUnPasTerreLune(x, y, vx, vy, valeurs);
		
		//dx  = valeurs[0]
		//dy  = valeurs[1]
		//dvx = valeurs[2]
		//dvy = valeurs[3]
		
        x += valeurs[0];
        y += valeurs[1];
        vx += valeurs[2];
        vy += valeurs[3];
		xg = x;
		yg = y;
		// CADRAGE
        if (x<1) xg = 1;
        if (x>XMAX) xg = XMAX;
        if (y<1) yg = 1;
        if (y>YMAX) yg = YMAX;
		
		// AFFICHAGE
		Bdisp_AllClr_DDVRAM();
		RestoreDisp(1);
		vit = sqrt(vx*vx+vy*vy);
		sprintf(affiche,"Vitesse:");
		PrintMini(0,YVITESSE,affiche,0);
		sprintf(affiche,"%5.2f Km/s",COEFR*(vit));
		PrintMini(0,YVITESSE+6,affiche,0);
        affiche_vaisseau(xg,yg);
		Bdisp_PutDisp_DD();
		Sleep(100);
		
		// INTERACTION POUR MANOEUVRES
		// Augmenter vitesse de DVINC
		if(IsKeyDown(137) || IsKeyDown(30018)){
            vx = vx+DVINC*vx/vit;
            vy = vy+DVINC*vy/vit;
		}
		// quitter
		if(IsKeyDown(30002)){
			succes=3;
			break;
		}
		// Reduire vitesse de DVINC
		if(IsKeyDown(153) || IsKeyDown(30023)){
            vx = vx-DVINC*vx/vit;
            vy = vy-DVINC*vy/vit;
		}
		
		// TESTS
		// Passage de la lune
		if(x<XL) passLune=1;
		// Crash Terre
		crashT = crashed(RAYT, XTB, YT, x, y);
        if(crashT){
			if(passLune) succes=1;
			break;
		}
		// Crash Lune
		if(crashed(RAYL, XL, YL, x, y)){
			break;
		}
    }
	return succes;
}

// OK
anime5(double x, double y, double vx, double vy, int tmax)
{
	int succes = 0;
	int nbrDemiTour = 0;
	int i=0;
	double vit;
	double valeurs[4];
	double xg, yg;
	
	while (i<tmax){
		i++;
        integreUnPasTerreLune(x, y, vx, vy, valeurs);
		
		//dx  = valeurs[0]
		//dy  = valeurs[1]
		//dvx = valeurs[2]
		//dvy = valeurs[3]
		
        x += valeurs[0];
        y += valeurs[1];
        vx += valeurs[2];
        vy += valeurs[3];
		xg = x;
		yg = y;
		// CADRAGE
        if (x<1) xg = 1;
        if (x>XMAX) xg = XMAX;
        if (y<1) yg = 1;
        if (y>YMAX) yg = YMAX;
		
		// AFFICHAGE
		Bdisp_AllClr_DDVRAM();
		RestoreDisp(1);
		vit = sqrt(vx*vx+vy*vy);
		sprintf(affiche,"Vitesse:");
		PrintMini(0,YVITESSE,affiche,0);
		sprintf(affiche,"%5.2f Km/s",COEFR*(vit));
		PrintMini(0,YVITESSE+6,affiche,0);
        affiche_vaisseau(xg,yg);
		Bdisp_PutDisp_DD();
		Sleep(100);
		
		// INTERACTION POUR MANOEUVRES
		// Augmenter vitesse de DVINC
		if(IsKeyDown(137) || IsKeyDown(30018)){
            vx = vx+DVINC*vx/vit;
            vy = vy+DVINC*vy/vit;
		}
		// quitter
		if(IsKeyDown(30002)){
			succes=3;
			break;
		}
		// Reduire vitesse de DVINC
		if(IsKeyDown(153) || IsKeyDown(30023)){
            vx = vx-DVINC*vx/vit;
            vy = vy-DVINC*vy/vit;
		}
		
		// TESTS
		// Passage de la lune
		if(x<XL && y==YL && (nbrDemiTour==0 || nbrDemiTour==2)) nbrDemiTour++;
		if(x>XL && y==YL && nbrDemiTour==1) nbrDemiTour++;
		if(nbrDemiTour==3){
			succes=1;
			break;
		}
		// Crash Terre
        if(crashed(RAYT, XTB, YT, x, y)){
			break;
		}
		// Crash Lune
		if(crashed(RAYL, XL, YL, x, y)){
			break;
		}
    }
	return succes;
}

// OK
integreUnPasTerre(double x, double y, double vx, double vy, double *valeurs)
{
    // Intégration du mouvement (Pas de temps = 1 seconde)
	double force[2];
	// force[0] = fx
	// force[1] = fy
    forceSubie(GMMT, XTA, YT, x, y, force);
	
	
    // "Equation fondamentale de la dynamique ..."
    valeurs[2] = force[0]/2;
    valeurs[3] = force[1]/2;
    valeurs[0] = vx+valeurs[2];
    valeurs[1] = vy+valeurs[3];
}

// OK
integreUnPasTerreLune(double x, double y, double vx, double vy, double *valeurs)
{
    // Intégration du mouvement (dt = 1 seconde) avec 2 CORPS attractifs
	double force[4];
	// force[0] = fx
	// force[1] = fy
    forceSubie(GMMT, XTB, YT, x, y, force);
	force[2]=force[0];
	force[3]=force[1];
	forceSubie(GMML, XL, YL, x, y, force);
	force[0]+=force[2];
	force[1]+=force[3];
    // "Equation fondamentale de la dynamique ..."
    valeurs[2] = force[0]/2;
    valeurs[3] = force[1]/2;
    valeurs[0] = vx+valeurs[2];
    valeurs[1] = vy+valeurs[3];
}

// OK
forceSubie(double Gm1m2, double xc, double yc, double x, double y, double *force)
{
	// Calcule la force d'attraction subie par le satellite 
    // vers le Corps terre ou lune, de constante d'attraction Gm1m2
    // (inclut les masses m1 et m2)
    double xSatCorps = xc-x;
    double ySatCorps = yc-y;
    double r = sqrt(xSatCorps*xSatCorps+ySatCorps*ySatCorps);
    force[0] = xSatCorps*Gm1m2/r/r/r;
    force[1] = ySatCorps*Gm1m2/r/r/r;
	return 1;
}

// OK
crashed(double RayCorps, double xc, double yc, double x, double y)
{
	int boum;
    double xSatCorps = xc-x;
    double ySatCorps = yc-y;
    double r = sqrt(xSatCorps*xSatCorps+ySatCorps*ySatCorps);
    if (r<RayCorps) boum = 1;
    else boum = 0;
    return boum;
}

// OK
GeoOK(double x, double y)
{
	int zoneOK;
    double xSatCorps = XTA-x;
    double ySatCorps = YT-y;
    double r = sqrt(xSatCorps*xSatCorps+ySatCorps*ySatCorps);
    if ((r<RGEOMAX)&&(r>RGEOMIN)) zoneOK=1;
    else zoneOK=0;
    return zoneOK;
}

// OK
affiche_vaisseau(int x, int y)
{
	Bdisp_SetPoint_VRAM((int)(x+0.5),(int)(y+0.5),1);
	if(vaissseau==2){
		Bdisp_SetPoint_VRAM((int)(x+0.5)+1,(int)(y+0.5),1);
		Bdisp_SetPoint_VRAM((int)(x+0.5)-1,(int)(y+0.5),1);
		Bdisp_SetPoint_VRAM((int)(x+0.5),(int)(y+0.5)+1,1);
		Bdisp_SetPoint_VRAM((int)(x+0.5),(int)(y+0.5)-1,1);
	}
	return 1;
}

// OK ?
RTC_getTicks()
{
     return (*SysCall)(0, 0, 0, 0, 0x3B);
}

// OK ?
rand_int(int max)
{
    return rand() % max;
}